import java.util.Date;


public class JemuxDate implements JemuxCommandInterface
{
	public JemuxDate(String[] args)
	{
		this.args = args;
		init();
	}

	public void init()
	{
		if (args.length!=0)
		{
			if (args[0].equals("--help"))
			{
				System.out.println(getHelp());
			}
			else
			{
				System.err.println("date: wrong argument!");
			}
		}
		else
		{
			System.out.println(new Date());
		}
	}

	public String getHelp()
	{
		return "[date] - shows current date and time\n" +
			"usage:   date";
	}

	private String[] args;
}
