import java.io.*;
import java.util.*;
import java.security.*;


public class JemuxLogin
{
	String username;
	String password;
	String hostname;
	String[] USERDATA;
	String[] TOKENS;
	JemuxUser GoodUser;				// user created by successful login
	JemuxFileHandler file = new JemuxFileHandler();
	private int MAXUSERS = 16;		// currently JEmuX can handle 16 users

	public JemuxLogin()
	{
		try {
			hostname = file.getFileContent("etc/hostname")[0];
			printLoginOSName();
		} catch (IOException ioe) {
			System.out.println(ioe);
			System.exit(-1);
		}
	}

	public void getUandP() throws NoSuchAlgorithmException
	{
		username = Console.readLine("username:");
		//MD5Password encPwd = new MD5Password(Console.readLine("password:"));
		MD5Password encPwd = new MD5Password(Console.readPassword("password:"));
		password = encPwd.getEncodedPassword();
	}

	private void printLoginOSName()
	{
		System.out.println("\n*** JEmuX ***");
		System.out.println();
		System.out.println("Welcome to "+hostname);
		System.out.println();
		System.out.println();
	}

	public String getUserName()
	{
		return username;
	}

	public String getHostName()
	{
		return hostname;
	}

	public JemuxUser getGoodUser()
	{
		return GoodUser;
	}

	public boolean gotAccess() throws IOException
	{
		StringTokenizer tokenizer;
		USERDATA = file.getFileContent("etc/passwd");
		int j = USERDATA.length;
		int k;

		TOKENS = new String[7];		// each line has 7 fields

		for (int i=0; i<j; i++)
		{
			if (USERDATA[i].charAt(USERDATA[i].length()-1)!=';')
			{
				System.err.println("[ERROR]: Missing \";\" at the end of line "+(i+1)+" of \"/etc/passwd\" file!");
				System.exit(-1);
			}
			else
			{
				USERDATA[i] = USERDATA[i].substring(0,USERDATA[i].length()-1);		// if ";" char exists, erases it
				tokenizer = new StringTokenizer(USERDATA[i], ":");

				/* assigns each passwd's field to the respective token in TOKENS[k] */
				k = 0;
				while (tokenizer.hasMoreTokens())
				{
					TOKENS[k] = tokenizer.nextToken();
					k++;
				}
				if (username.equals(TOKENS[0])&&password.equals(TOKENS[1]))
				{
					GoodUser = new JemuxUser(TOKENS[0], TOKENS[2], Integer.parseInt(TOKENS[3]), Integer.parseInt(TOKENS[4]), TOKENS[5], TOKENS[6]);
					return true;
				}
				else if (username.equals(TOKENS[0])&&(TOKENS[1].equals("*")))
				{
					System.out.println("User \""+TOKENS[0]+"\" is currently disabled.");
				}
			}
		}
		System.out.println("Sorry.");
		System.out.println();
		return false;
	}
}
