public class JemuxEcho implements JemuxCommandInterface
{
	public JemuxEcho(String[] args)
	{
		this.args = args;
		init();
	}

	public void init()
	{
		if (args.length!=0)
		{
			if (args[0].equals("--help"))
			{
				System.out.println(getHelp());
			}
			else
			{
				int n = args.length;
				String output = "";

				for (int i=0; i<n; i++)
				{
					if (args[i]!=null)
					{
						if ((args[i].charAt(0)=='\"')&&(args[i].charAt(args[i].length()-1)=='\"'))
						{
							args[i] = args[i].substring(1, args[i].length()-1);// or "-2" ?!?
						}
						output += args[i]; // problem with white spaces!!! solve it!!!
					}
				}
  		  		System.out.println(output);
			}
		}
		else
		{
			System.out.println();
		}
	}

	public String getHelp()
	{
		return "[echo] - this command prints a given string of text\n" +
			"usage:   echo <string>";
	}

	private String[] args;
}
