public class JemuxId implements JemuxCommandInterface
{
	public JemuxId(String[] args, JemuxUser user)
	{
		this.args = args;
		this.user = user;
		init();
	}

	public void init()
	{
		if(args.length!=0)
		{
			if (args[0].equals("--help"))
			{
				System.out.println(getHelp());
			}
		}
		else
		{
			System.out.println("uid="+user.getUID()+"("+user.getUserName()+") gid="+user.getGID()+"("+user.getUserGroup()+")");
		}
	}

	public String getHelp()
	{
		return "[id] - prints some information about a user\n" +
			"usage:   id <username>";
	}

	private String[] args;
	private JemuxUser user;
}
