/***
questa classe e' molto molto molto grezza,
bisogna sistemare parecchie cose:
- lettura di piu' parametri (usare ciclo while)
- e' la shell che deve gestire i percorsi, non ogni singolo comando
- rendere il tutto piu' modulare (cioe' "+ metodi - lunghi")
***/


import java.lang.*;
import java.io.File;


public class JemuxLs implements JemuxCommandInterface
{
	public JemuxLs(String[] args, JemuxUser user)
	{
		this.args = args;
		this.user = user;
		init();
	}

	public void init()
	{
		if (args.length!=0)
		{
			if (args[0].equals("--help"))
			{
				System.out.println(getHelp());
			}
			else
			{
				if (args[0].equals("-a"))
				{
  					File[] fileArrayPartial = new File(user.getRealPath()+user.getUserCurrDir()).listFiles();//
					File[] fileArray = newFileArray(fileArrayPartial);

					int maxSizeLength = 0;

					System.out.println("total "+fileArray.length);

  					for (int k=0; k<fileArray.length; k++)
  					{
						int temp = new Long(fileArray[k].length()).toString().length();

						if (maxSizeLength<temp)
						{
							maxSizeLength = temp;
						}
  					}

  					for (int i=0; i<fileArray.length; i++)
  					{
						String output = "";
						int temp = new Long(fileArray[i].length()).toString().length();

						output += (fileArray[i].isDirectory())?"d":"-";
						output += (fileArray[i].canRead())?"r":"-";
						output += (fileArray[i].canWrite())?"w":"-";
						output += (fileArray[i].isHidden())?"-":"x";
						for (int t=0; t<=(maxSizeLength-temp); t++)
							output += " ";
						output += "  "+new Long(fileArray[i].length()).toString();
						output += "   "+new java.util.Date(fileArray[i].lastModified());
						output += "   "+fileArray[i].getName();
						/*
							show "." and ".." for curr and prev dir!
						*/
						System.out.println(output);
  					}
  		  		}
  	  		}
		}
    	else
  		{
  			String[] fileList = (new File(user.getRealPath()+user.getUserCurrDir())).list();//
  	 		for (int i=0; i<fileList.length; i++)
			{
				if (fileList[i].charAt(0)!='.') // files beginning with "." are hidden on UNIX
				{
  	 	  			System.out.println(fileList[i]);
				}
			}
  		}
	}

	private File[] newFileArray(File[] fileArrayPartial)
	{
		File[] fileArray = new File[fileArrayPartial.length+2];

		fileArray[0] = new File(user.getRealPath()+user.getUserCurrDir()); // sforano fuori dalla root!!! occhio!!!
		fileArray[1] = new File(fileArray[0].getParent());

  		for (int i=0; i<fileArrayPartial.length; i++)
		{
			fileArray[i+2] = fileArrayPartial[i];
		}

		return fileArray;
	}

	public String getHelp()
	{
		return "[ls] - this command lists files in a directory\n" +
			"usage:   ls [options] <directory>\n" +
			"    options:\n" +
			"        -a			prints whole files information\n";
	}

	private String[] args;
	private JemuxUser user;
}
