public class JemuxWhoami implements JemuxCommandInterface
{
	public JemuxWhoami(String[] args, JemuxUser user)
	{
		this.args = args;
		this.user = user;
		init();
	}

	public void init()
	{
		if (args.length!=0)
		{
			if (args[0].equals("--help"))
			{
				System.out.println(getHelp());
			}
			else
			{
				System.err.println("whoami: wrong argument!");
			}
		}
		else
		{
			System.out.println(user.getUserName());
		}
	}

	public String getHelp()
	{
		return "[whoami] - this commands prints user's login name\n" +
			"usage:   whoami";
	}

	private String[] args;
	private JemuxUser user;
}
